hmLoadTopic({
hmKeywords:"",
hmTitle:"Customizing sentences",
hmDescription:"The methods described in the Using sentence templates help topic to use conditional switches and field options can also be applied to the local version of a sentence template...",
hmPrevLink:"using-sentence-templates.html",
hmNextLink:"sentence-template-language.html",
hmParentLink:"fact-sentences.html",
hmBreadCrumbs:"<a href=\"working-with-facts.html\">Working with Facts<\/a> &gt; <a href=\"fact-sentences.html\">Fact sentences<\/a>",
hmTitlePath:"Working with Facts > Fact sentences > Customizing sentences",
hmHeader:"<h1 class=\"p_Heading1\" style=\"page-break-after: avoid;\"><span class=\"f_Heading1\">Customizing sentences<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_Normal\">The methods described in the <a href=\"using-sentence-templates.html\" class=\"topiclink\">Using sentence templates<\/a> help topic to use conditional switches and field options can also be applied to the local version of a sentence template for an individual. This has the effect of creating a variation of the sentence that is different from the default.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Lets look at a basic example discussed in the the <a href=\"using-sentence-templates.html\" class=\"topiclink\">Using sentence templates<\/a> topic.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[person:Given:Surname]&nbsp;was&nbsp;born&lt;&nbsp;[date]&gt;&lt;&nbsp;[placedetails]&gt;&lt;&nbsp;[place]&gt;.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">which would display the following in the narrative report:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">John Harold Doe was born in 1827 in Barnet, Caledonia County, Vermont.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">After you add the default fact to the person, the sentence preview is shown at the bottom of the fact pane. Above the preview is a link to a command, Customize, that displays the Customize Sentence window.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<div class=\"p_Normal\"><img alt=\"RM9_EditPerson-CustomizeSentence-2\" style=\"width:90%;max-width:577px;height:auto;border:none\" src=\".\/images\/rm9_editperson-customizesentence-2.jpg\"\/><\/div>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Let\'s apply a few fairly typical scenarios to this sentence template to show you further examples of the flexibility of this feature. (You are probably more creative that the examples shown here, but they are meant to get you thinking of the possibilities.)<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span style=\"font-weight: bold;\">Example 1: Rearranging elements in the Sentence Template to add variety to your sentences.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">The arrangement of elements in the example sentence above is typical of the Modified Register form (date before place). The Register form of sentences is typically (place before data) as in<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[person:Given:Surname]&nbsp;was&nbsp;born&lt;&nbsp;[placedetails]&gt;&lt;&nbsp;[place]&gt;&lt;&nbsp;[date]&gt;.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">which would displayed the following in the narrative report:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">John Harold Doe was born at 123 Any Street in Barnet, Caledonia County, Vermont in 1827.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">You could just change some of the sentences this was for variety. If you prefer the Register form, you could change the default templates for all the facts in the database to put the date field at the end.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">For further variety, you may want to put the date at the beginning of the template, as in this example using the Living fact type:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;&nbsp;[date]&gt;[person:Given:Surname]&nbsp;was&nbsp;living&lt;&nbsp;[placedetails]&gt;&lt;&nbsp;[place]&gt;.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">This would produce something like:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">in February 1964John Harold Doe was living in Honolulu, Hawaii.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Notice the issues with this: there is a space at the start of the sentence, the word &quot;in&quot; is not capitalized, and there is no space or comma between 1964 and John. (note that &quot;in&quot; is used because the date is incomplete.) This is easily corrected by changing <span style=\"font-weight: bold;\">&lt; [date]&gt;<\/span> to <span style=\"font-weight: bold;\">&lt;[date:caps]<\/span>, &gt; to produce:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">In February 1964, John Harold Doe was living in Honolulu, Hawaii.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">This type of change will add variety to your sentences. Tip: If you have a number of fact types that you use regularly, you could modify of few of them to rearrange elements so the sentence construction varies in a person\'s life story.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span style=\"font-weight: bold;\">Example 2: Adding a twin<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Suppose our John Doe had a twin sister, Elizabeth, and she was entered separately into the database. How can we show that John and Elizabeth are twins, but not add this detail to all instances where the birth fact is used. This is where we can use the Customize feature to modify the local instance of the sentence template.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">First let\'s <a href=\"sharing-facts.html\" class=\"topiclink\">add them sharing<\/a> each others birth facts with a new role <span style=\"font-weight: bold;\">[Twin]<\/span>. In this case, I am not going to add a sentence template when I add them to share this event, because I am going to include them in each other\'s customized birth fact. (If I added a role sentence for them, that sentence would appear as well as the phrase I\'m about to enter – creating a duplication.)<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Since Elizabeth is in the database, we would add her to share John\'s birth fact via the <span style=\"font-weight: bold;\">&quot;Add a Person, Choose witness from list&quot;<\/span> menu adding the role [Twin]. When we add John to Elizabeth\'s birth fact, we can select the role [Twin] since it is now in the list of roles associated with the birth fact. (It can also be used for other sets of twins as well.)<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Now in the Customize birth sentences for John and Elizabeth, lets inset the phrase &quot;<span style=\"font-weight: bold;\">&lt;, twin &lt;%brother |sister |&gt;of [Twin:First],&gt;&quot;<\/span> without the quotes so the customize sentence template reads:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[person:Given:Surname]&lt;,&nbsp;twin&nbsp;&lt;%brother&nbsp;|sister&nbsp;|&gt;of&nbsp;[Twin:First],&gt;&nbsp;was&nbsp;born&lt;&nbsp;[date]&gt;&lt;&nbsp;[placedetails]&gt;&lt;&nbsp;[place]&gt;.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">This phrase uses the gender switch &lt;%...&gt; to tell RootsMagic to insert &quot;brother&quot; if the subject is male, &quot;sister&quot; if the subject is female, or no word or space if the sex is unknown. It also uses the :First field option to tell RootsMagic to only display the first name. You could also use :Given if desired.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">The resulting sentences that would be displayed in the narrative report are, respectively:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">John Harold Doe, twin brother of Elizabeth, was born in 1827 in Barnet, Caledonia County, Vermont.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Elizabeth Doe, twin sister of John, was born in 1827 in Barnet, Caledonia County, Vermont.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span style=\"font-weight: bold;\">Example 3: Adding a triplet (or quadruplet, quintuplets, etc.)<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">This technique can be use with triplets or quads, etc. Note that you only have to create one role, say [Triplet]. When you encounter this (and haven\'t pre-entered the role), you can add this new role to the first of the triplets. For the others, you can then select the role already entered.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Let\'s say Josephine, Elizabeth and Mary Jane Stevens were identical triplets. Follow the above instructions, but use the phrase <span style=\"font-weight: bold;\">&quot;&lt;, identical triplet &lt;%brother |sister |&gt;of [Triplet:First],&gt;&quot;<\/span> without the quotes so the customized sentence template reads:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[person:Given:Surname]&lt;,&nbsp;identical&nbsp;triplet&nbsp;&lt;%brother&nbsp;|sister&nbsp;|&gt;of&nbsp;[Triplet:First],&gt;&nbsp;was&nbsp;born&lt;&nbsp;[date]&gt;&lt;&nbsp;[placedetails]&gt;&lt;&nbsp;[place]&gt;.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">The resulting sentences would read:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Josephine Stevens, identical triplet sister of Elizabeth and Mary, was born in 1827 in Barnet, Caledonia County, Vermont.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Elizabeth Stevens, identical triplet sister of Josephine and Mary, was born in 1827 in Barnet, Caledonia County, Vermont.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Mary Jane Stevens, identical triplet sister of Josephine and Elizabeth, was born in 1827 in Barnet, Caledonia County, Vermont.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">This works because RootsMagic accepts multiple people assigned a role, and when it does, it creates a list of people separated by commas, and inserts &quot;and&quot; before the last person. If the triplets were not identical, you would leave that word out.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span style=\"font-weight: bold;\">Tip:<\/span> Each time you create a new phrase such as these (and have the &quot;bugs&quot; worked out), you may want to reuse them in the future. Open a document in your favorite word processor and copy the phrases there for quick access. (It is easier than trying to remember where in the database you used a specific phrase.) Whether you use it exactly as you initially entered it or not, it can be a basis for additional creativity and can save time extending the basic fact sentence for shared roles.<\/p>\n\r<p class=\"p_BodyText\"><span class=\"f_BodyText\">&nbsp;<\/span><\/p>\n\r<p class=\"p_BodyText\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">Note<\/span><span class=\"f_BodyText\">: If you customize a sentence for a fact and later want to return it to its default, just click the &quot;Reset to Default&quot; button.<\/span><\/p>\n\r"
})
