hmLoadTopic({
hmKeywords:"",
hmTitle:"Date formats",
hmDescription:"RootsMagic supports a variety of date formats for data entry, and a wide variety of date modifiers and qualifiers that appear before the actual date (BC appears after the...",
hmPrevLink:"adding-facts.html",
hmNextLink:"date-tools.html",
hmParentLink:"adding-facts.html",
hmBreadCrumbs:"<a href=\"working-with-facts.html\">Working with Facts<\/a> &gt; <a href=\"adding-facts.html\">Adding facts<\/a>",
hmTitlePath:"Working with Facts > Adding facts > Date formats",
hmHeader:"<h1 class=\"p_Heading1\" style=\"page-break-after: avoid;\"><span class=\"f_Heading1\">Date formats<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_Normal\">RootsMagic supports a variety of date formats for data entry, and a wide variety of date modifiers and qualifiers that appear before the actual date (BC appears after the date.) Double dates and Quaker dates are also supported.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Date Formats<\/span><\/h2>\n\r<p class=\"p_Normal\">Any date you type in the Date field will be accepted. Recognized dates will be converted into a standard format for displaying and printing. RootsMagic includes an option in &quot;Settings, General Settings&quot; to let you choose between day-month-year or month-day-year for data entry. Even if the date you enter is not converted to a standard format, such as &quot;the first Wednesday after the big fire in 1808&quot;, RootsMagic will still accept the date as you typed it into the Date field. However, you must enter your own sort date to tell RootsMagic where to locate the fact in relation to the other facts.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">RootsMagic highlights unrecognized dates by changing the background field color to a pale yellow. Unrecognized dates entered into the sort date field will also be highlighted in yellow, but the unrecognized date will be discarded from the sort date field when your click the Save button.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">It is not necessary to enter a full day, month and year if you don’t know them. You can enter complete dates or partial dates, into both the data field or the sort date field, like:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">2 Jan 1900<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Jan 1900<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">1900<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Jan<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">2 Jan<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Note that 2 1890 will be converted to Feb 1890. If you find a date where you can only read the day and year, you can enter the date as 2 ??? 1890,and RootsMagic will sort the date after year-only (1890) date, but before a 1 Jan 1890 date.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">RootsMagic also supports BC dates<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>BC – Before Christ or Before the Common Era (e.g. 100 BC)<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Double dates<\/span><\/h2>\n\r<p class=\"p_Normal\">Double dates were used after the Gregorian Calendar was introduced in 1583 to replace the Julian Calendar, because of inaccuracies in the Julian Calendar leap year calculations. The Julian Calendar used March 25 as the start of the new year and March 24 as the last day of the year. The Gregorian calendar moved the start of the year to January 1. The Gregorian calendar wasn\'t adopted by the British empire (including its colonies, the US and Canada) until 1752 and other countries as later as 1923. In the intervening years, dates between Jan. 1 and Mar. 24 were written as 15 Feb 1675\/6 to indicate the year was 1675 on the Julian (or Old Style) calendar, but was 1676 on the Gregorian (or New Style) calendar. RootsMagic displays the year with one digit after the \/ for most years, except it shows 2 digits for a decade, i.e. 1679\/80, or 4 digits for a century, i.e. 1699\/1700.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Double dates entered with years before 1583\/4 are treated as unrecognized dates, while double dates entered for 25 Mar to 31 Dec after 1583 are also treated as unrecognized dates.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Quaker dates<\/span><\/h2>\n\r<p class=\"p_Normal\">RootsMagic has built-in date support for Quaker dates. Quaker date are written referring to days of the weeks and months of the year by their number rather than the names which were based on &quot;pagan&quot; gods.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">RootsMagic accepts these dates as &quot;12day 5month 1588&quot; or &quot;12da 5mo 1588&quot;, and displays them as &quot;12da 5mo 1588&quot;. Note that Quaker dates before 1752 were based on the Julian Calendar, so the first month refers to March, not January. Thus the sort date for the above date would be 12 July 1588, and the sort date for 2da 1mo 1588 would be 2 Mar 1588. Double dates are supported with Quaker dates, so the sort date for 2da 1mo 1588\/9 would be 2 Mar 1589. Also, the various date modifiers and qualifiers can be used with Quaker dates.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Date modifiers and date qualifiers<\/span><\/h2>\n\r<p class=\"p_Normal\">RootsMagic offers two types of date &quot;modifiers&quot;, directional (including date-range) modifiers and qualitative modifiers, both of which can be added to dates. Directional modifiers and qualitative modifiers and be used in the same date field, but the qualitative modifiers will not be included in the sort date field.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Bullet\"><span class=\"f_Bullet\" style=\"font-weight: bold;\">Single date directional modifiers<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Before – Before a date (e.g. before 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">By – Used as a date by which something happened (e.g.by 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">To – Used as an end date for an unknown period (e.g. to 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Until – Until a date (e.g. until 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">From – Used as a start date for an unknown period (e.g. from 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Since – Since a date (e.g. since 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">After – After a date (e.g. aft 1 Jan 1900<\/span>)<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span style=\"font-weight: bold;\">Date-range directional modifiers<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Between\/And – A date which is between two dates (e.g. between 1 Jan 1900 and 5 Jan 1900.) Between by itself is treated as an unrecognized date. Dates entered with &quot;and&quot; as in &quot;1 Jan 1900 and 5 Jan 1900&quot; are converted to between\/and dates.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">From\/To – Used as a date period (e.g. from 1 Jan 1900 to 5 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">&quot;–&quot; – (a long &quot;n&quot; dash) Used for a date period (e.g. 1 Jan 1900–5 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Or – Conflicting dates (e.g. 1 Jan 1900 or 5 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span style=\"font-weight: bold;\">Date Qualifiers<\/span><\/p>\n\r<p class=\"p_Normal\">RootsMagic offers a set of date &quot;qualifiers&quot; which can be added to dates and date modifiers. Qualifiers assign a level of uncertainty in the date because of the way they were derived. Qualifiers can be included in the date field with directional modifiers.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">About – Near a date (e.g. abt 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Estimated – An estimated date (e.g. est 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Calculated – A calculated date (e.g. calc 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Circa – An estimated date (e.g. ca 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Say – An estimated date (e.g. say 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span style=\"font-weight: bold;\">Qualitative modifiers<\/span><\/p>\n\r<p class=\"p_Normal\">Qualitative modifiers are terms that refer to levels of confidence in the data, and form a relative hierarchy. (The hierarchy does not affect the sort order because qualitative modifiers are not stored in the sort date field.) These terms take on whatever sense the writers create with their supporting details and interpretations. Qualitative modifiers can be included in the date field with directional modifiers. The qualitative modifiers built into RootsMagic are shown below:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Certainly – no reasonable doubt about a date (e.g. cert 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Probably – a more likely than not date (e.g. prob 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Possibly – some evidence supports the date (e.g. poss 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Likely – odds weigh slightly in favor of a date (e.g. lkly 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Apparently – a presumed, but not tested, date (e.g. appar 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Perhaps – data that suggests the date is plausible, but not tested (e.g. prhps 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Maybe – a date which may be correct, but there is little or no data to support it (e.g. maybe 1 Jan 1900)<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Other qualitative terms can be entered into the Date field, such as &quot;almost certainly&quot;, &quot;quite likely&quot;, and &quot;presumably&quot;, but they will be treated as an unrecognized date, and will not produce a sort date. If you enter one of these unrecognized terms, the date field background will turn yellow, but you can enter a sort date manually to have the fact situated as desired within the fact list and the outputs will use the data in the field exactly as entered.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span style=\"font-weight: bold;\">Sort dates<\/span><\/p>\n\r<p class=\"p_Normal\">Only directional date modifiers are stored in the Sort date field, qualitative modifiers are not. For example, a date entered as &quot;certainly before 25 Dec 1859&quot;, will have a sort date of &quot;bef 25 Dec 1859&quot; – &quot;certainly&quot; is not stored.. As a result, dates with directional modifiers are sorted before or after dates with qualitative modifiers (in the Date field.) Directional modifiers are sorted in the following order:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Bet ... and ...<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">from ... to ...<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">&quot;dash&quot;<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">&quot;or&quot;<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Before<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">By<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">To (by itself)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Until<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">(plain dates, or dates with no directional modifier in the sort date field)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">From (by itself)<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Since<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">After<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span style=\"font-weight: bold;\">Sorting events on the same date<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">On occasion events can happen on the same date, such as a death, the funeral, and the burial. If these events were entered into RootsMagic with the same date, the order may be random, likely making the events appear out of order, such as burial, funeral, death. To avoid this, you would enter the correct date into the fact date field, and then append a dash and number to the sort date to force the events into the correct order, e.g.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<div style=\"text-align: left; text-indent: 0; padding: 0 0 0 0; margin: 1.0000rem 0 1.0000rem 0;\"><table style=\"width:40.4375rem; background-color:#f8f9fa; border:none; border-spacing:0; border-collapse:collapse;\">\n\r<tr>\n\r<td style=\"vertical-align:middle; width:7.9375rem; background-color:#004000; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Fact<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; width:11.1875rem; background-color:#004000; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Date field<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; width:19.2500rem; background-color:#004000; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Sort date field<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; width:7.9375rem; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Death<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; width:11.1875rem; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">12 Jan 1875<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; width:19.2500rem; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">12 Jan 1875–1<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; width:7.9375rem; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Funeral<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; width:11.1875rem; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">12 Jan 1875<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; width:19.2500rem; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">12 Jan 1875–2<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; width:7.9375rem; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Burial<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; width:11.1875rem; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">12 Jan 1875<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; width:19.2500rem; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">12 Jan 1875–3<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<\/table>\n\r<\/div>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r"
})
