hmLoadTopic({
hmKeywords:"",
hmTitle:"Fact types",
hmDescription:"In RootsMagic, a fact type is an item that defines an event. Fact types can have one or two principals and any number of associated witnesses. A principal is a primary person...",
hmPrevLink:"moving-or-copying-a-fact.html",
hmNextLink:"adding-roles.html",
hmParentLink:"working-with-facts.html",
hmBreadCrumbs:"<a href=\"working-with-facts.html\">Working with Facts<\/a>",
hmTitlePath:"Working with Facts > Fact types",
hmHeader:"<h1 class=\"p_Heading1\" style=\"page-break-after: avoid;\"><span class=\"f_Heading1\">Fact types<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_Normal\">In RootsMagic, a fact type is an item that defines an event. Fact types can have one or two principals and any number of associated witnesses. A principal is a primary person or couple involved in an event, while a witness is a person who may have observed the event or otherwise shared in the event. As an example, a child is the principal in the birth event, while the doctor would be a person who shared in the birth event. In another example, the bride and groom are the principals in a wedding, the best man and maid of honor would be legal witnesses, while the minister, ushers and bridesmaids shared in the event.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Fact types can be either Individual (with one principal) or Family (with two principals.) Family fact types tie the two people together into a family relationship. For example, some of the Individual fact types are: Birth, Death, Burial, Education, Graduation, and Occupation, while some of the Family fact types are: Marriage, Engagement, and Divorce. These and many more are defined in the program and these built-in fact types include the GEDCOM abbreviations. You can use the fact types as is, or you can edit fact types to tailor the fact types to your preference or your style.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Adding a new Fact Type<\/span><\/h2>\n\r<p class=\"p_Normal\">You can design new fact types for your database. When you create a new fact type, it is applicable only to the database in which you created it. If you open another database and want to use the new fact type, you must add the fact type to the other database separately.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">The principals and witnesses or people sharing a fact type are assigned &quot;Roles.&quot; Each role can have its own sentence template. The role sentence for the principal is also the fact sentence. Each role has its own note field where you can enter additional details when a person is assigned to the role. These role sentences and role notes only appear in narrative reports and websites, with the role note following the sentence for the respective role. Role sentences and role notes do not appear in any of the other reports.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span style=\"font-weight: bold;\">To create a new fact type:<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span>Open the Fact Type dialog (either by clicking the 3 dots options button on the People page and selecting &quot;Fact type list&quot;, or by adding a fact to a person). RootsMagic will ask if you want to create an Individual or a Family fact type. Individual facts are specific to one person (like a birth, death, etc). Family facts attach to a couple (like marriage, divorce, etc).<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<div class=\"p_Normal\"><img alt=\"RM9_FactType-Add\" style=\"width:90%;max-width:706px;height:auto;border:none\" src=\".\/images\/rm9_facttype-add.jpg\"\/><\/div>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span>Enter the information\/select the options for the new fact type in the Fact Type Setup area.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<div class=\"p_Normal\"><img alt=\"RM9_FactType-Edit\" style=\"width:90%;max-width:788px;height:auto;border:none\" src=\".\/images\/rm9_facttype-edit.jpg\"\/><\/div>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 1.6250rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">A.<\/span>Name – Enter the name of the fact type.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 1.6250rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">B.<\/span>Abbreviation – Enter a short name for the fact type. This abbreviation is used in places where space is tight.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 1.6250rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">C.<\/span>Use date field – If you want to be able to enter a date for this fact type, mark this checkbox.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 1.6250rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">D.<\/span>Use place field – If you want to be able to enter a place for this fact type, mark this checkbox.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 1.6250rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">E.<\/span>Use description field – If you want to be able to enter a description for this fact type, mark this checkbox. The description field is useful for facts like occupation (e.g. &quot;teacher&quot;) or illness (e.g. &quot;measles&quot;).<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 1.6250rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">F.<\/span>Include when – Select when you want this fact type to be used.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 3.2500rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span>Exporting GEDCOM files – Check this item if you want to include this fact type when exporting to GEDCOM files.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 3.2500rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span>Creating web sites – Check this item if you want to include this fact type when creating websites.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 3.2500rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span>Family group sheets – Check this item if you want to include this fact type when printing family group sheets.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 3.2500rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">4.<\/span>Narrative reports – Check this item if you want to include this fact type when printing narrative reports.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 3.2500rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">5.<\/span>Individual summaries – Check this item if you want to include this fact type when printing individual summaries.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 3.2500rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">6.<\/span>Printed lists – Check this item if you want to include this fact type when printing lists<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span>Select the default role, Principal, and click &quot;Edit Role&quot;.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">4.<\/span>Tell RootsMagic how to write the sentence for this role – In the fact sentence for the Principal role, you tell the program how to write the fact sentence to include the principal(s) and the other fact fields - dates, places, place details, and\/or description. Further details on how to write these sentences. The Shared roles that you defined in the above steps 3 &amp; 4 are generally added to the individual fact sentence through the Customize local Sentence dialog. However, you should plan your fact sentence with the idea of incorporating the shared roles into or appended to the fact sentence.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">5.<\/span>Click OK to accept the sentence you entered – the sentence template will appear below the role name in the right column – or click Cancel to discard the changes.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">6.<\/span>Click OK to save the new fact type and close the dialog. To close the dialog without saving the new fact type, click Cancel.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Editing a Fact Type<\/span><\/h2>\n\r<p class=\"p_Normal\">To edit a fact type, open the Fact Type list by clicking the 3 dot options button on the People page and select Fact type list. RootsMagic will open the same form described in &quot;Adding a new Fact Type&quot; where you can make changes to the fact type. &nbsp;Additionally you will be able to add new roles to the fact type. &nbsp;Click &quot;Add Role&quot; to define a new role. (We\'ll get back to the Principal role shortly.)<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<div class=\"p_Normal\"><img alt=\"RM9_FactType-Role\" style=\"width:90%;max-width:496px;height:auto;border:none\" src=\".\/images\/rm9_facttype-role.jpg\"\/><\/div>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 1.6250rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">A.<\/span>Enter a name for the new role – Role names are descriptive names that identify the role played by the person in the context of this fact type.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 1.6250rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">B.<\/span>Tell RootsMagic how to write the sentence for this role – This is where you tell the program how to write a sentence (for books and websites) when this role is encountered for a person with this fact type. You write the sentence with &quot;fields&quot; to show where things like names, dates, place details, places, and the description field fit. Here is information on how to write these sentences.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 1.6250rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">C.<\/span>Click OK to accept the sentence you entered – The new role will appear in the left column and the sentence template will appear below the role name in the right column. Click Cancel to close the dialog without adding the new role.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Click &quot;Add Role&quot; as above to define as many new roles as necessary.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Deleting a Fact Type<\/span><\/h2>\n\r<p class=\"p_Normal\">If you previously created a fact type that you no longer use, you may delete it from the list of fact types. You cannot, however, delete a predefined fact type (a standard fact type that came with the program). &nbsp;Also, if you try to delete a fact type that is being used in your database, you will be warned by RootsMagic. If you choose to continue deleting the fact type, all facts of that type will be removed from your database.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">To delete a fact type:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_Bullet\">Click the 3 dot options button on the People page and select &quot;Fact type list&quot;.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_Bullet\">In the Select Fact Type dialog that opens, highlight the fact you want to delete and click the &quot;Delete&quot; button.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_Bullet\">Answer Yes on the confirmation dialog to delete the fact type, or click No to cancel the deletion. If you highlighted a predefined fact type, a dialog will remind you that you cannot delete this fact type.<\/span><\/p>"
})
