hmLoadTopic({
hmKeywords:"",
hmTitle:"Sentence template language",
hmDescription:"Note: This help item is common to both Fact Sentence templates and Source templates. Some items are applicable to only one of the two template types.",
hmPrevLink:"customizing-sentences.html",
hmNextLink:"sharing-facts.html",
hmParentLink:"fact-sentences.html",
hmBreadCrumbs:"<a href=\"working-with-facts.html\">Working with Facts<\/a> &gt; <a href=\"fact-sentences.html\">Fact sentences<\/a>",
hmTitlePath:"Working with Facts > Fact sentences > Sentence template language",
hmHeader:"<h1 class=\"p_Heading1\" style=\"page-break-after: avoid;\"><span class=\"f_Heading1\">Sentence template language<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_Normal\"><span style=\"font-weight: bold;\">Note:<\/span> This help item is common to both Fact Sentence templates and Source templates. Some items are applicable to only one of the two template types.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Sentence templates allow you to tell RootsMagic how to write a sentence for a given fact or source citation. You simply write a sentence with &quot;fields&quot; and “switches” to show where things like names, dates, and places fit. Square brackets [ ] indicate the name of a field to be displayed, while angle brackets &lt; &gt; indicate a switch, or conditional statement, that will determine what, if any, data is displayed.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">There are two types of templates: Fact Sentence Templates and Source Templates. Fact Sentence Templates are used when a particular fact is written in a narrative report or website. Source Templates are used when a source citation is written in a report or a website. While each type of template has its own unique features, they both share the same basic usage and rules.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Fields<\/span><\/h2>\n\r<p class=\"p_Normal\">Fields are pieces of a template that are replaced with meaningful text at the time the sentence is written. They are written using square brackets with the name of the field inside. Field names are not case sensitive, so for example, [Date], [date], [daTe], [DATE] are all equivalent field names. Through out this topic, most have the first letter Capitalized so they stand out, especially when several words are used together like PlaceDetails. Fields in a fact sentence template may look like this:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[Person]&nbsp;was&nbsp;born&lt;&nbsp;[Date]&gt;&lt;&nbsp;[PlaceDetails]&gt;&lt;&nbsp;[Place]&gt;.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">In this example, when RootsMagic encounters a person’s birth when writing a narrative report, it takes this template and replaces [Person] with the person’s name, [Date] with the date of the birth, [PlaceDetails] with the details (hospital or address) within the place where the birth occurred, and [Place] with the place (city, county, state, country) of birth.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Fields in a source template for the full (first) footnote may look like:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[Author],&nbsp;&lt;i&gt;[Title]&lt;\/i&gt;&nbsp;([PubPlace]:&nbsp;[Publisher],&nbsp;[PubDate]).<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">while the fields in a source template for the bibliography might look like:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[Author:Reverse].&nbsp;&lt;i&gt;[Title]&lt;\/i&gt;.&nbsp;[PubPlace]:&nbsp;[Publisher],&nbsp;[PubDate:Year].<\/span><\/p>\n\r<p class=\"p_BodyText\"><span class=\"f_BodyText\">&nbsp;<\/span><\/p>\n\r<p class=\"p_Normal\">In this example, when RootsMagic encounters a book source, it replaces the source fields [Author] with the author of the book, [Title] with the title of the book, [PubPlace] with the place of publication, [Publisher] with the name of the publisher, and [PubDate] with the date of publications (usually a year.) You will also note the and formatting codes which tell RootsMagic to format the text in italics font, :Reverse tells RootsMagic to show the surname first, and :year tells RootsMagic to show only the year part of the date.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h3 class=\"p_Heading3\" style=\"page-break-after: avoid;\"><span class=\"f_Heading3\">Fact Sentence Fields<\/span><\/h3>\n\r<p class=\"p_Normal\">Fact sentence templates are created using a combination of pre-defined fields referring to a person or persons, pre-defined fields referring to fact details, as well as plain text and punctuation. Formatting codes can be used in Fact sentence templates, if desired, but are more commonly used in the Notes field to emphasize a portion of the note text. The field names and field options in templates are not case sensitive – they can be all lower case, all upper case, or first letter of each word capitalized, etc. First letter capitalization is used here, particularly where multiple words are involved, to make it easier for people to read.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">The pre-defined fields for use in fact sentence templates are:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<div style=\"text-align: left; text-indent: 0; padding: 0 0 0 0; margin: 1.0000rem 0 1.0000rem 0;\"><table style=\"width:40.4375rem; background-color:#f8f9fa; border:none; border-spacing:0; border-collapse:collapse;\">\n\r<tr>\n\r<td style=\"vertical-align:middle; width:6.4375rem; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Field<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; width:8.0625rem; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Field Type<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; width:23.5000rem; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Description<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td colspan=\"3\"  style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fields referring to a person or persons:<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">[Person]<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">1 person<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">The principal person of the event<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">[Spouse]<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">1 person<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">The spouse of the principal person<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">[Couple]<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">1 or 2 people<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Both the principal person and spouse, if entered<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">[Husband]<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">1 person<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">The husband in the principal person’s marriage<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">[Wife]<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">1 person<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">The wife in the principal person’s marriage<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">[ThisPerson]<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">1 person<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">The main witness that the witness sentence is about. Witness fact sentences only.<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">[OtherPersons]<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">1 or more person<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">All witnesses to the event, regardless of role. In witness fact sentences, this excludes the main witness.<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">[Role]<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">1 or more person<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">All witnesses to the event with the specified role. The name of the role is typed in square brackets, e.g. [Witness], [Doctor], [Minister]<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">[Field(#)]<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">1 person<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">In the case of fields that refer to more than one person, you can refer to a specific person by number by writing the number in parentheses after the field name. For example, to get the 3rd bridesmaid, type [Bridesmaid(3)].<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">[Field 1,Field 2,…]<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">1 or more person<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Any number of person fields may be combined into a single group by writing all the field names within square brackets, separated by commas. For example, to get all the groomsmen and bridesmaids, type [Groomsman,Bridesmaid].<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td colspan=\"3\"  style=\"vertical-align:middle; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Fields referring to fact details:<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">[Date]<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Date<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">The date of the event<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">[Place]<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Place<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">The place where the event happened<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">[PlaceDetails]<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Place<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Details about the place where the event happened (for example, the name of the church or cemetery, or the street address)<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">[Desc]<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Description<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">The description of the fact<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<\/table>\n\r<\/div>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h3 class=\"p_Heading3\" style=\"page-break-after: avoid;\"><span class=\"f_Heading3\">Source Fields<\/span><\/h3>\n\r<p class=\"p_Normal\">Source fields are defined for each source template. To use that field in a template, type its name in square brackets, or you can drag the field from the field list into the respective template (full footnote, short footnote or bibliography). A source template is made up of source fields, plain text and punctuation, as well as formatting codes when required.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Field Options<\/span><\/h2>\n\r<p class=\"p_Normal\">You can set options for every field that control both what is written and how it is written. You type the options within the field’s square brackets. You can add as many options as necessary to a field, each option separated by a colon, but no extra spaces. For example:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[Witness(4):Surname:Caps]<\/span><\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&nbsp;<\/span><\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[Person:Given:Surname]<\/span><\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&nbsp;<\/span><\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[PublishDate:Year]<\/span><\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&nbsp;<\/span><\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[Place:Reverse:Proper]<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<div style=\"text-align: left; text-indent: 0; padding: 0 0 0 0; margin: 1.0000rem 0 0 0;\"><table style=\"width:40.4375rem; background-color:#f8f9fa; border:none; border-spacing:0; border-collapse:collapse;\">\n\r<tr>\n\r<td style=\"vertical-align:middle; width:6.6250rem; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Option<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; width:11.5625rem; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Field Type<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; width:19.8125rem; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Description<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td colspan=\"3\"  style=\"vertical-align:middle; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Capitalization Options<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:NoCaps<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Any<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Default. Makes no changes in capitalization.<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Upper<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Any<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Changes to upper case, e.g. “JOHN DOE”<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Lower<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Any<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Changes to lower case, e.g. “john doe”<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Caps<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Any<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Capitalizes the first letter and makes no changes to subsequent letters, e.g. “John doe”<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Proper<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Any<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Forces “proper” capitalization, e.g. “John Doe”<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td colspan=\"3\"  style=\"vertical-align:middle; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Abbreviation Options<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:NoAbbrev<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Source Template<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Default. Look for a &quot;||&quot; and process the information that precedes it, e.g. Post Office Box 1010 &quot;||&quot; PO Box 1010 = Post Office Box 1010<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Abbrev<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Source Template<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Look for a &quot;||&quot; and process the information that follows it, e.g. Post Office Box 1010 &quot;||&quot; PO Box 1010 = PO Box 1010<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td colspan=\"3\"  style=\"vertical-align:middle; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Name Part Options (May include one or more)<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Full<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Name &amp; Witness names<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Dr. John Robert “Johnny” Doe Jr.<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Reverse<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Name &amp; Witness names<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Doe, Dr. John Robert “Johnny” Jr. (reverses first name in a group only)<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Given<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Name &amp; Witness names<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">John Robert<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:First<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Name &amp; Witness names<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">John<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Surname<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Name &amp; Witness names<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Doe<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Prefix<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Name<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Dr.<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Suffix<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Name<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Jr.<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Nickname<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Name<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Johnny<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Casual<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Name &amp; Witness names<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Nickname, if known, otherwise first name<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td colspan=\"3\"  style=\"vertical-align:middle; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Age Options<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Plain<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Age<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">No prefix.<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:At<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Age<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">“at the age of Age”. Default for fact\/role sentence ages<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Commas<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Age<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">“, age Age,”<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td colspan=\"3\"  style=\"vertical-align:middle; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Fact Place Options<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Original<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Place in Fact\/Role Sentences<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Original version of place (default), e.g. “Brownsville, Utah Territory”<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Short<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Place in Fact\/Role Sentences<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Abbreviated version of place, e.g. “Ogden, Utah”<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td colspan=\"3\"  style=\"vertical-align:middle; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Place Options<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Full<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Place or Place Details in source template or fact\/role sentence<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Ames, Story, Iowa, United States<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Reverse<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Place or Place Details in source template or fact\/role sentence<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">United States. Iowa. Story. Ames<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:ReverseComma<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Place or Place Details in source template or fact\/role sentence<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">United States, Iowa, Story, Ames<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:First<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Place or Place Details in source template or fact\/role sentence<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Ames<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Last<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Place or Place Details in source template or fact\/role sentence<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">United States<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td colspan=\"3\"  style=\"vertical-align:middle; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Place &amp; Description Prefix Options<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Plain<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Place, Place Details, or Description<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">No prefix. Default for source templates and description fields<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:In<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Place, Place Details, or Description<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">“In Text”. Default for fact\/role sentence places<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:At<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Place, Place Details, or Description<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">“At Text”. Default for fact\/role sentence place details<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:A<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Place, Place Details, or Description<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">“A Text” or “An Other text”<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td colspan=\"3\"  style=\"vertical-align:middle; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Date Options<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Plain<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Date<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Full date, e.g. “6 Apr 1830”, no &quot;in&quot; or &quot;on&quot; prefix. (Default for source templates)<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:InOn<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Date<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">“on 6 Apr 1830” or “in Apr 1830”. (Default for fact\/role sentences.)<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Year<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Date<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Year only, e.g. “1830”<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:DayOfWeek<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Date<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Show the day of week with the date, e.g. “Tuesday 6 Apr 1830”<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:NoDayOfWeek<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Date<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Removes the day of week from the date (default)<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Commas<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Date<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Adds commas to the date, e.g. &quot;6 Apr, 1830” or “Tuesday, 6 Apr, 1830”<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:NoCommas<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Date<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Removes commas from the date (default)<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td colspan=\"3\"  style=\"vertical-align:middle; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Person Options<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Name<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fact Sentence People<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Default. The names of the people in roles<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Poss<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fact Sentence People<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Possessive form of names, e.g. John\'s. To get the full name possessive, i.e. “John Doe’s”, you would enter [Person:Full:Poss]<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:HeShe<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fact Sentence People<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">He\/She\/They<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:HisHer<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fact Sentence People<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">His\/Her\/Their<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:HimHer<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fact Sentence People<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Him\/Her\/Them<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Age<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fact Sentence People<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Age of person at time of event<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Role<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fact Sentence People<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Role of witness<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Count<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fact Sentence People<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\"># of people in the group, i.e. [role1,role2,role3:count], e.g. [child:count] or [son,daughter:count]<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td colspan=\"3\"  style=\"vertical-align:middle; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Person Name Cycling Options<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:Cycle<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fact Sentence People<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Prints the full name first and then cycles between He\/She and the casual name in subsequent uses. Default for “Person” and “Couple” in regular fact sentences and default for “ThisPerson” in witness fact sentences.<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">:NoCycle<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fact Sentence People<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Print the name as specified without cycling<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<\/table>\n\r<\/div>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Formatting Codes<\/span><\/h2>\n\r<p class=\"p_Normal\">Formatting codes allow you to tell RootsMagic how you want the font to look in the report. Formatting codes are contained inside of a left angle bracket &quot;&lt;&quot; and right angle bracket &quot;&gt;&quot;. They are used in pairs - the first tells RootsMagic to turn on the formatting, and the second, with a &quot;\/&quot; after the left angle bracket (&lt;\/ &gt;) to turn off the formatting. For example:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;i&gt;[Title]&lt;\/i&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">The &lt;i&gt; and &lt;\/i&gt; formatting codes tell RootsMagic to display the title in italics font.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<div style=\"text-align: left; text-indent: 0; padding: 0 0 0 0; margin: 1.0000rem 0 1.0000rem 0;\"><table style=\"width:40.4375rem; background-color:#f8f9fa; border:none; border-spacing:0; border-collapse:collapse;\">\n\r<tr>\n\r<td style=\"vertical-align:middle; width:10.4375rem; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Field<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; width:10.4375rem; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Field Type<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; width:17.1875rem; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Description<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td colspan=\"3\"  style=\"vertical-align:middle; background-color:#006F62; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableHeading\"><span class=\"f_TableHeading\">Formatting Codes<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">&lt;i&gt; ... &lt;\/i&gt;<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fact sentence and Source templates, fields, and notes<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Displays the text in italics<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">&lt;b&gt; ... &lt;\/b&gt;<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fact sentence and Source templates, fields, and notes<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Displays the text in bold<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">&lt;u&gt; ... &lt;\/u&gt;<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fact sentence and Source templates, fields, and notes<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Displays the text in underline<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">&lt;sc&gt; ... &lt;\/sc&gt;<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fact sentence and Source templates, fields, and notes<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Displays the text in SMALL CAPS (upper case letters remain unchanged, lower case letters are changed to upper case, but in a smaller font)<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">&lt;sup&gt; ... &lt;\/sup&gt;<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fact sentence and Source templates, fields, and notes<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Displays the text in superscript<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<tr>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">&lt;sub&gt; ... &lt;\/sub&gt;<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Fact sentence and Source templates, fields, and notes<\/span><\/p>\n\r<\/td>\n\r<td style=\"vertical-align:middle; padding:0.0625rem; border:solid thin #a0a0a0;\"><p class=\"p_TableBody\"><span class=\"f_TableBody\">Displays the text in subscript<\/span><\/p>\n\r<\/td>\n\r<\/tr>\n\r<\/table>\n\r<\/div>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Switches<\/span><\/h2>\n\r<p class=\"p_Normal\">A switch allows you to write different information, depending on the information that is available. Switches are contained inside of a less-than and greater-than sign (&lt; &gt;). Inside of the switch are any number of pieces, separated by a “|”. For example:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;First&nbsp;Piece|Second&nbsp;Piece|Third&nbsp;Piece|Fourth&nbsp;Piece&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">You can set the kind of switch by using a special character after the first less-than sign. There are five special switch characters, ? for the Value switch, % for the Gender switch, @ for the Living switch, # for the Plural switch, and ! for the Private switch. For example:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;%actor|actress&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">In a switch that depends on information about a person or a group of people, such as value switches, gender switches, living switches, and plural switches, you can specify which person or group of people the switch applies to by writing the field names of the people either immediately after the special character (living, plural) or enclosed in square brackets ([value], [gender]) and then followed by the special character again.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;#Doctors#doctor|doctors&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Two of the switches, Gender (%) and Living (@), will refer directly to the focus subject if a field name is not entered. For example:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;@He&nbsp;is&nbsp;living|He&nbsp;is&nbsp;not&nbsp;living&gt;.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">The Private switch (!) is used in source templates to privatize things such as a street address data that you want to record, but not make public. The trigger that activates the Private switch is a checkbox in the Sources, Options tab in the Report Settings dialog.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h3 class=\"p_Heading3\" style=\"page-break-after: avoid;\"><span class=\"f_Heading3\">Simple Switches<\/span><\/h3>\n\r<p class=\"p_Normal\">A simple switch requires no special character and can have any number of pieces.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;First&nbsp;Piece|Second&nbsp;Piece|Third&nbsp;Piece|Fourth&nbsp;Piece&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">RootsMagic will look at each piece, beginning with the first. If the piece has a field with a value, or has no fields, it is written and all the remaining pieces are skipped. For example, lets look at the basic birth sentence with conditional brackets added:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[Person]&nbsp;was&nbsp;born&lt;&nbsp;[Date]&gt;&lt;&nbsp;[PlaceDetails]&gt;&lt;&nbsp;[Place]&gt;.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">The angle brackets &lt; &gt; indicate that if there is no value entered, neither the field nor the space before it will be shown. This applies to the [date], [placedetails] and [place] fields.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">In the following source templates examples:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;privately&nbsp;held&nbsp;by&nbsp;[LastKnownOwner],&nbsp;&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">would only write something if “[LastKnownOwner]” has a value, or in this example:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;[Format],|digital&nbsp;image,&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">would write “database and digital images,” if that\'s what you entered into the [Format] field, or it would write &quot;digital image,” if you didn’t enter anything into the [Format] field.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h3 class=\"p_Heading3\" style=\"page-break-after: avoid;\"><span class=\"f_Heading3\">Value Switches<\/span><\/h3>\n\r<p class=\"p_Normal\">A value switch is similar to a simple switch except that it allows you to check for a value without actually writing that value. It is indicated by a “?”.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;?[Expression]|&nbsp;Show&nbsp;this&nbsp;if&nbsp;True.&gt;<\/span><\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&nbsp;<\/span><\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;?[Expression]|&nbsp;Show&nbsp;this&nbsp;if&nbsp;True.&nbsp;|&nbsp;Show&nbsp;this&nbsp;if&nbsp;False.&gt;<\/span><\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&nbsp;<\/span><\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;?[Expression]||&nbsp;Show&nbsp;this&nbsp;if&nbsp;False.&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">For example:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;?[Nurse]|He&nbsp;had&nbsp;a&nbsp;nurse.&gt;<\/span><\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&nbsp;<\/span><\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;?[Nurse]|He&nbsp;had&nbsp;a&nbsp;nurse.|He&nbsp;didn\'t&nbsp;have&nbsp;a&nbsp;nurse.&gt;<\/span><\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&nbsp;<\/span><\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;?[Nurse]||He&nbsp;didn\'t&nbsp;have&nbsp;a&nbsp;nurse.&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">would check to see if the role of [Nurse] had a value. If it did, it would write “He had a nurse.” If it did not have a value, it would write “He didn\'t have a nurse.”<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Note that what comes after the “?” is different from the gender and living switches. The gender and living switches need the role of a person or group of people followed by their special character. The value switch takes any expression including fields in brackets and other switches.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h3 class=\"p_Heading3\" style=\"page-break-after: avoid;\"><span class=\"f_Heading3\">Gender Switches<\/span><\/h3>\n\r<p class=\"p_Normal\">A gender switch checks the gender of a person or group of people and writes the appropriate text. It is indicated by a “%”. It is of the form:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span class=\"f_CodeExample\">&lt;% Males &amp; Unknowns &gt;<\/span> or<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span class=\"f_CodeExample\">&lt;% Males &amp; Unknowns | Females &gt;<\/span> or<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span class=\"f_CodeExample\">&lt;% Males | Females |Unknowns &gt;<\/span> or<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span class=\"f_CodeExample\">&lt;% Male | Female | Unknown | Multiples &gt;<\/span> or<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span class=\"f_CodeExample\">&lt;% Male | Female | Unknown | Male &amp; Mixed Multiples | Female Multiples &gt;<\/span> or<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;%&nbsp;Male&nbsp;|&nbsp;Female&nbsp;|&nbsp;Unknown&nbsp;|&nbsp;Male&nbsp;Multiples&nbsp;|&nbsp;Female&nbsp;Multiples&nbsp;|&nbsp;Mixed&nbsp;Multiples&nbsp;&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">or it can take the form to process a list of one or more roles<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;%roles%|&nbsp;Male&nbsp;|&nbsp;Female&nbsp;|&nbsp;Unknown&nbsp;|&nbsp;Male&nbsp;Multiples&nbsp;|&nbsp;Female&nbsp;Multiples&nbsp;|&nbsp;Mixed&nbsp;Multiples&nbsp;&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">In this first example, the switch looks at the default [person]:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;%He&nbsp;was&nbsp;an&nbsp;actor.|She&nbsp;was&nbsp;an&nbsp;actress.&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">In this second example, the switch looks at the role name [child]:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;%Child%[child]&nbsp;was&nbsp;a&nbsp;son.|[child]&nbsp;was&nbsp;a&nbsp;daughter.|[child]&nbsp;was&nbsp;a&nbsp;child.|[child]&nbsp;were&nbsp;sons.|[child]&nbsp;were&nbsp;daughters.|[child]&nbsp;were&nbsp;children.&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">In the first example, the &quot;person&quot; is the focus person to which the sentence applies. In the second example, [child] refers to a role assigned to someone in a shared event. The role [child] could be assigned to one or more people.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span style=\"font-weight: bold;\">Note:<\/span> Roles, which are added as &quot;Just type name of witness&quot; menu, or &quot;This person is NOT in the file&quot; in Edit Share Event, do not have a gender, and may affect results of this switch.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h3 class=\"p_Heading3\" style=\"page-break-after: avoid;\"><span class=\"f_Heading3\">Living Switches<\/span><\/h3>\n\r<p class=\"p_Normal\">A living switch checks if a person or group of people is living and writes the appropriate text. It is indicated by a “@”. It is of the form:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span class=\"f_CodeExample\">&lt;@ Living &gt;<\/span> or<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;@&nbsp;Living&nbsp;|&nbsp;Not&nbsp;Living&nbsp;&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;@roles@&nbsp;Show&nbsp;this&nbsp;if&nbsp;all&nbsp;Living&nbsp;|&nbsp;Show&nbsp;this&nbsp;if&nbsp;one&nbsp;or&nbsp;more&nbsp;Not&nbsp;Living&nbsp;&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">For example:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span class=\"f_CodeExample\">&lt;@He has brown hair.|He had brown hair.&gt;<\/span> (This assumes that his hair never turned gray.)<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;@Doctors,Nurses@They&nbsp;are&nbsp;doctors&nbsp;and&nbsp;nurses.|They&nbsp;were&nbsp;doctors&nbsp;and&nbsp;nurses.&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h3 class=\"p_Heading3\" style=\"page-break-after: avoid;\"><span class=\"f_Heading3\">Plural Switches<\/span><\/h3>\n\r<p class=\"p_Normal\">A plural switch looks at the number of people in a group and writes the appropriate text. It is indicated by a “#”. It is of the form:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span class=\"f_CodeExample\">&lt;#roles# Single &gt;<\/span> or<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span class=\"f_CodeExample\">&lt;#roles# Single | Plural &gt;<\/span> or<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;#roles#&nbsp;Single&nbsp;|&nbsp;Plural&nbsp;|&nbsp;None&nbsp;&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">For example:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;#Doctors#His&nbsp;doctor&nbsp;was|His&nbsp;doctors&nbsp;were&gt;&nbsp;[Doctor].<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">They&nbsp;had&nbsp;&lt;#Children#a&nbsp;child|&lt;[Children:count]&gt;&nbsp;children|no&nbsp;children&gt;.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">There&nbsp;&lt;#Heir1,Heir2#was&nbsp;one&nbsp;heir|was&nbsp;more&nbsp;than&nbsp;one&nbsp;heir|were&nbsp;no&nbsp;heirs&gt;.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h3 class=\"p_Heading3\" style=\"page-break-after: avoid;\"><span class=\"f_Heading3\">Private Switches<\/span><\/h3>\n\r<p class=\"p_Normal\">A private switch is used for fact sentence templates and source templates. For sources, this allows you to write different text depending on whether you have or have not checked the <span style=\"font-weight: bold;\">&quot;Hide private data in the endnotes, footnotes, and bibliography&quot;<\/span> option in the Sources, Options tab, telling RootsMagic whether to display the private or the not private information for this switch. It is of the form:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;!&nbsp;NotPrivate&nbsp;|&nbsp;Private&nbsp;&gt;<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">For example:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">&lt;!&lt;[Address]&gt;|(The&nbsp;address&nbsp;is&nbsp;private.)&gt;.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">If the checkbox is checked, &quot;(The address is private.)&quot; would print. If the checkbox was unchecked, the address data that was entered in the [Address] field would print, if one was entered, otherwise nothing would print.<\/p>\n\r<p class=\"p_BodyText\"><span class=\"f_BodyText\">&nbsp;<\/span><\/p>\n\r<h3 class=\"p_Heading3\" style=\"page-break-after: avoid;\"><span class=\"f_Heading3\">Switches Within Switches<\/span><\/h3>\n\r<p class=\"p_Normal\">RootsMagic allows you to put switches within other switches, also known as nesting. This allows you to create very powerful and flexible sentence templates.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Escape Characters<\/span><\/h2>\n\r<p class=\"p_Normal\">If you ever want to write an actual &lt;, &gt;, \/, [, or ] in your sentence, you must precede it by a “\/”. This tells RootsMagic that to print the following character and to not treat it as a switch or a field. For example:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span class=\"f_CodeExample\">[Person] \/[This is in brackets\/].<\/span> would print:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">John Doe [This is in brackets].<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">and <span class=\"f_CodeExample\">[person] is a \/[person\/]<\/span> would print<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">John Doe is a [person].<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">thus allowing the keyword &quot;person&quot; to be enclosed within square brackets without being interpreted as a field.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Tip: To include a field value within square brackets, such as [John Doe], you can enclose the field within a switch with the square brackets outside the switch, i.e. <span class=\"f_CodeExample\">[&lt;[person]&gt;]<\/span>.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r"
})
