hmLoadTopic({
hmKeywords:"",
hmTitle:"Sharing facts",
hmDescription:"While some events (facts) apply primarily to one person, such as education, illness, military service, occupation, many events involve other people. Some of these other people...",
hmPrevLink:"sentence-template-language.html",
hmNextLink:"working-with-places.html",
hmParentLink:"working-with-facts.html",
hmBreadCrumbs:"<a href=\"working-with-facts.html\">Working with Facts<\/a>",
hmTitlePath:"Working with Facts > Sharing facts",
hmHeader:"<h1 class=\"p_Heading1\" style=\"page-break-after: avoid;\"><span class=\"f_Heading1\">Sharing facts<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\"><span class=\"f_BodyText\">While some events (facts) apply primarily to one person, such as education, illness, military service, occupation, many events involve other people. Some of these other people may be actual witnesses, but many just share the event. For example, there are witnesses to the signing of a legal document such as a marriage, a will or codicil, or a land instrument. Even though there are witnesses (best man and maid of honor) to the marriage, there usually are others involved who share in the event, such as the minister, the bridesmaids and ushers, ring bearer and flower girl, parents of the bride and parents of the groom groom, etc. For a census, there are no witnesses, just people who share the fact because they were enumerated at the same time. Similarly for an obituary, there are rarely any witnesses, but the obituary will mention relatives, some who passed away before the deceased person, and many who survive after the passing.<\/span><\/p>\n\r<p class=\"p_BodyText\"><span class=\"f_BodyText\">The &quot;Share&quot; feature in RootsMagic lets you share a person’s fact or event with other people in your database, by assigning roles to the other people involved in the event. For some events like marriage, the role could be a witness or minister, or best man or maid of honor, while for other events like a census or residence there would be no witnesses per se, but those mentioned would be assigned roles like wife, child (or son or daughter), father, mother, father-in-law, mother-in-law, niece, nephew, sister, brother, boarder or domestic, or a whole range of other possible roles.<\/span><\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Sharing Facts<\/span><\/h2>\n\r<p class=\"p_Normal\">To create a shared fact:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span>Select a fact in the Edit Person form and either:<\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0 0 0.3125rem 0.8125rem;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Click Shared in the edit panel<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0 0 0.3125rem 0.8125rem;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Click the shared column in the fact list<\/span><\/p>\n\r<p class=\"p_Normal\" style=\"margin: 0 0 0 0.8125rem;\">&nbsp;<\/p>\n\r<p class=\"p_BodyText\"><span class=\"f_BodyText\">RootsMagic will display a list of anyone who shares the fact.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"margin: 0 0 0.6250rem 1.6250rem;\"><img alt=\"RM10_EditPerson-SharedEvent-Panel\" style=\"margin:0;width:22.0000rem;height:34.0625rem;border:none\" src=\".\/images\/rm10_editperson-sharedevent-panel.jpg\"\/><\/p>\n\r<p class=\"p_BodyText\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0;\"><span class=\"f_BodyText\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyText\">Click the &quot;Share fact&quot; button to add one or more persons who share the fact.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"margin: 0 0 0.6250rem 1.6250rem;\"><img alt=\"RM10_EditPerson-SharedEvent-SelectPeople\" style=\"margin:0;width:68.6875rem;height:45.6250rem;border:none\" src=\".\/images\/rm10_editperson-sharedevent-selectpeople.jpg\"\/><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span>There are 2 ways to add a person (or persons) who shares the fact:<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 1.6250rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">A.<\/span><span style=\"font-weight: bold;\">Select people<\/span> - You can select one or more people from the list displayed. The highlighted person\'s data is displayed to the right of the list.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin: 0 0 0 1.6250rem;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">B.<\/span><span style=\"font-weight: bold;\">Just type name<\/span> - This lets you just type in the name of a person who is not in the database. While this lets you share the fact with someone not in the file, it also has limitations because the only info for the person is their name. Enter the first name and last name of the witness – this can include prefixes in the first name field such as Mrs. or Dr. if a given name is not known, or suffixes such as Jr. or Esq. in the last name field. However, if you specify the :first or :casual field option for the name, the first item in the field will be shown, even if that part is &quot;Dr.&quot; rather than the actual first first name. Similarly, the complete Last name field contents will be shown if you specify the :Surname or :Reverse field option for the name.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span>Select a role for the witness from the drop down list, or add a new role name.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span>Enter a note associated with this person in the selected role. This will appear as a separate sentence following the role sentence.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">4.<\/span>Click OK to save the entry as a person sharing the fact, or click Cancel to close the dialog without saving the entry.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Editing a Shared Fact<\/span><\/h2>\n\r<p class=\"p_Normal\">To edit a shared fact, select a fact in the Edit Person form and either:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>Click Shared in the edit panel<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>Click the shared column in the fact list<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">You will see a list of everyone who is sharing that fact. Just click on the person you want to edit.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<div class=\"p_Normal\" style=\"margin: 0 0 0 1.6250rem;\"><img alt=\"RM9_EditPerson-Panel-EditSharedEvent\" style=\"width:90%;max-width:317px;height:auto;border:none\" src=\".\/images\/rm9_editperson-panel-editsharedevent.jpg\"\/><\/div>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">If the person is in the database you will see their name, and clicking that name lets you change the person if desired.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">If the person was a typed in name, you will see 2 fields (Given and Surname) which you can edit.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">In either case you will also be able to edit:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>Role – Select a role for the witness from the drop list, or select Add new witness type... to add a new role. In the dialog, enter the new role name and enter a sentence template for the role. (This will be added to list of roles for the Fact Type when saved.) Click OK to save the role, or Cancel to exit without saving.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>Note – Enter a note associated with this person in the selected role. This will appear as a separate sentence following the role sentence.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Deleting a Shared Fact<\/span><\/h2>\n\r<p class=\"p_Normal\">To remove a person who shares a fact, simply repeat the steps from &quot;Editing a Shared Fact&quot;, and click the Trash Can button on the edit panel.<\/p>\n\r<p class=\"p_BodyText\"><span class=\"f_BodyText\">&nbsp;<\/span><\/p>\n\r<p class=\"p_BodyText\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">Note:<\/span><span class=\"f_BodyText\"> Shared facts are not always transferable to other programs or websites.<\/span><\/p>\n\r"
})
