hmLoadTopic({
hmKeywords:"",
hmTitle:"Source templates",
hmDescription:"Source templates tell RootsMagic how to take data entered into the source fields and create the source citation entry. There are almost 400 templates designed from models...",
hmPrevLink:"style-guides.html",
hmNextLink:"creating-a-source-template.html",
hmParentLink:"working-with-sources.html",
hmBreadCrumbs:"<a href=\"working-with-sources.html\">Working with Sources<\/a>",
hmTitlePath:"Working with Sources > Source templates",
hmHeader:"<h1 class=\"p_Heading1\" style=\"page-break-after: avoid;\"><span class=\"f_Heading1\">Source templates<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_Normal\">Source templates tell RootsMagic how to take data entered into the source fields and create the source citation entry. There are almost 400 templates designed from models published in style guides by Elizabeth Shown Mills and Richard S. Lackey.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<div class=\"p_Normal\"><img alt=\"RM9_Sources-Template-List\" style=\"width:90%;max-width:751px;height:auto;border:none\" src=\".\/images\/rm9_sources-template-list.jpg\"\/><\/div>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">As you\'ll notice in the list above and in the built-in source list, there can be multiple templates for a given type of source. Some of the templates for a given type are based on the jurisdiction which created or now controls those records (i.e. state vs. county vs. federal), others are based on the format in which the sources are available (original records, microfilm, CD\/DVD, online databases or images), while still others are based on the arrangement that the elements appear in the footnote or bibliography (for instance, author\/compiler, person of interest, or jurisdiction as lead element.) This allows users to select the source templates that best suits their needs and preferences.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">The Source Templates window displays a list of templates at the left, and the details for a template is displayed at the right. As you move from template to template, the display on the right is updated for each template highlighted.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span style=\"font-weight: bold;\">Shown at the right of the window are:<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\" style=\"font-weight: bold;\">Source Type<\/span><span class=\"f_Bullet\"> – the name of the source type. This is used in various lists to select the source type to use with people, families, or facts.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\" style=\"font-weight: bold;\">Description<\/span><span class=\"f_Bullet\"> – a description of the source type, occasionally referring to other templates<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\" style=\"font-weight: bold;\">Ref<\/span><span class=\"f_Bullet\"> – a Reference to the style guide from which the template was created. EE = Evidence Explained, QC = QuickCheck model in EE (QC-3 indicates a QuickCheck model in chapter 3), E! = Evidence!, QS = QuickSheet, CYS = Cite Your Sources.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\" style=\"font-weight: bold;\">Footnote<\/span><span class=\"f_Bullet\"> – the template to create the first full footnote when a source is used in a report.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\" style=\"font-weight: bold;\">Short Footnote<\/span><span class=\"f_Bullet\"> – the template to create the short footnote when the same footnote is used in subsequent locations in a report.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\" style=\"font-weight: bold;\">Bibliography<\/span><span class=\"f_Bullet\"> – the template to create the bibliographic entries that appear in the bibliography or in a source list in a report.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\" style=\"font-weight: bold;\">List of fields<\/span><span class=\"f_Bullet\"> – the primary details of the fields used in the template, the type of field contents, the text to be displayed beside the field, and which fields are part of the citation (or the source details). The field hint and long hint (shown as a question mark &quot;?&quot; symbol at the end of the field) are not shown here.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span style=\"font-weight: bold;\">The command available in the Source Templates window are:<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span style=\"font-weight: bold;\">Add<\/span> – click this button to define a new source template.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span style=\"font-weight: bold;\">Edit<\/span> – click this button to edit an existing source template. You can also double click on a source type to edit it. Note that you cannot edit a built-in template. If you need a modified version of a built-in template, use Copy to make a copy of the built-in template and edit the copy.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span style=\"font-weight: bold;\">Delete<\/span> – click this button to delete a source template. Note that you cannot delete a built-in template, only ones you create, copy or import.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0 0 0 1.6250rem;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>To delete an existing template, highlight the template you want to delete, and click the Delete button. You will be asked if you want to remove the source type from the database. Click Yes to delete the source type or No to cancel the command.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0 0 0 1.6250rem;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>If you click Yes, RootsMagic checks to see if there are any sources using the source type.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0 0 0 3.2500rem;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>If there are sources using the source, you will be notified of this, told that deleting the source will remove all sources of this type from your database, and asked to confirm that you are sure you want to delete it. Click Yes to delete the source type or No to cancel the command.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0 0 0 3.2500rem;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>If there are no sources using the source, the source type will be removed from the database<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span style=\"font-weight: bold;\">Export<\/span> – click this button to export an individual source template to use in another project or to share with others. Note that you cannot export a built-in template. The Export Source Template will let you give the template a name, and to pick a destination folder in which to save the template. The default is the &quot;data files&quot; folder. Click OK to export the template, and save it where you indicated.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span style=\"font-weight: bold;\">Import<\/span> – click this button to import a source template, exported from another project or received from another user. You will be prompted to select the file to Open. Navigate to the folder, highlight the file, and click Open. Click Cancel to close the dialog without importing a template.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span style=\"font-weight: bold;\">Copy<\/span> – click this button to make a copy of an existing source template, either built-in or user defined.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0 0 0 1.6250rem;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>To copy an existing template, highlight the template you want to copy, and click the Copy button. You will be asked if you want to make a copy. Click Yes to make the copy or No to cancel the command. If you choose Yes, a copy is created with (Copy) appended to the source type.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">See Also<\/span><\/h2>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\"><a href=\"creating-a-source-template.html\" class=\"topiclink\">Creating a source template<\/a><\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\"><a href=\"using-a-source-template.html\" class=\"topiclink\">Using a source template<\/a><\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\"><a href=\"sentence-template-language.html\" class=\"topiclink\">Source Template Language<\/a><\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\"><a href=\"user-source-templates.html\" class=\"topiclink\">User Submitted Source Templates<\/a><\/span><\/p>"
})
