hmLoadTopic({
hmKeywords:"",
hmTitle:"TMG Import",
hmDescription:"Direct TMG import is much more complicated than other imports because it tries to also preserve source and sentence templates. Often doing cleanup in TMG before importing into...",
hmPrevLink:"importing-data.html",
hmNextLink:"exporting-data.html",
hmParentLink:"importing-data.html",
hmBreadCrumbs:"<a href=\"databases.html\">Databases<\/a> &gt; <a href=\"importing-data.html\">Importing data<\/a>",
hmTitlePath:"Databases > Importing data > TMG Import",
hmHeader:"<h1 class=\"p_Heading1\" style=\"page-break-after: avoid;\"><span class=\"f_Heading1\">TMG Import<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_Normal\">Direct TMG import is much more complicated than other imports because it tries to also preserve source and sentence templates. Often doing cleanup in TMG before importing into RootsMagic will provide better results, as will some cleanup in RootsMagic after import.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Introduction<\/span><\/h2>\n\r<p class=\"p_Normal\">This document covers moving data from The Master Genealogist (TMG) into RootsMagic. RootsMagic provides a direct TMG import which provides much better results than using a GEDCOM transfer. Still, it is not possible to get a perfect one-to-one transfer because of the vastly different data models, template languages, etc. used by both TMG and RootsMagic. You will need to expect to do some cleanup when moving your data from TMG to RootsMagic (or any other program), but this document is intended to help guide you through some of that cleanup.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">RootsMagic’s direct TMG import attempts to preserve not only the basic genealogical information like names, events, notes, and media, but to also preserve witnesses (with roles), source templates, and sentence templates.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Known Issues<\/span><\/h2>\n\r<p class=\"p_Normal\">RootsMagic will attempt to import all information, but there will be some information which doesn’t appear in RootsMagic exactly the same as it appeared in TMG.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">In TMG a single “tag” type can have 1 or 2 “principals”, including individual facts like Occupation, Death, etc. RootsMagic on the other hand has 2 forms of fact types: individual or family. An individual fact type has 1 principal, and a family fact type has 2 principals. If a “tag” in TMG is used with 1 principal, RootsMagic will import it into an individual fact type. If a “tag” in TMG is used with 2 principals who are married or are the parents of one or more children, RootsMagic will import it into a family fact type.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Tags that are in the TMG Marriage and Divorce tag type groups will be imported as family fact types irrespective of whether they have one or two principals in TMG.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Event tags in TMG that have two principals who are not spouses will have the P2 changed to a witness using the role “Principal2” and will be imported as personal fact types.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">RootsMagic only supports the Principal role for principals. If you used other roles for principals in TMG, the Principal role for the fact types will need to be edited. You will also need to edit any sentences that use a role variable for a custom role that refers to the principal.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">History group tags in TMG aren’t imported because they have no “principal” and therefore aren’t attached to a person or family.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">If a TMG place has Detail data, the LatLong data will be imported to the Place Details Latitude\/Longitude fields.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Some fields in TMG sentence templates cannot be converted to RootsMagic fields. If a field doesn’t affect the actual sentence structure (like font fields) RootsMagic will attempt to just remove the field. If deleting the field would make the sentence template incomplete (like removing a [PO] field from an individual fact that doesn’t support a secondary principal), then RootsMagic will just leave the field in the template to assist with cleanup after the import.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">RootsMagic will import the source and source template intact for every source, but if the source template is modified for an individual source in TMG, RootsMagic will use the global source template for that source type.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">DNA tests will be imported, but the actual markers are not mapped to the markers in RM. The markers will be imported into the note for the DNA test.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Before Importing Your TMG Data<\/span><\/h2>\n\r<p class=\"p_Normal\">This section details clean-up items you should perform in TMG before importing into RootsMagic.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Use TMG Utility to export any “internal” media items to “external” media items.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">The TMG project should be using &quot;Custom&quot; source categories (Preferences \/ Current Project Options \/ Other).<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Import can uncover hidden problems with TMG sources. If a source doesn\'t import correctly, the problem likely is the TMG source. For example, in TMG, the source type and the fields on the Source Definition \/ General tab don\'t match. In this case, select a different source type and then reselect the original source type.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">The repository Name-Other field is not imported. Make sure you copy that to the Addressee field (if empty) or to the Memo field (if the Addressee field is used).<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Importing Your TMG Data<\/span><\/h2>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">The direct TMG import has been tested with TMG versions 7.04 and 9.03. The recommended TMG versions to use for import are 7.04, 8.08, or later.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Before import, run the TMG maintenance routines optimize, validate file integrity, optimize.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Make sure TMG files are not open in any program before trying to import them into RM.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Use several import cycles. Import. Check data. Make edits in TMG to improve import. Import again.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">After Importing Your TMG Data<\/span><\/h2>\n\r<p class=\"p_Normal\">Once you have done all possible cleanup in TMG and make your final import to RM...<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Check the roles and sentences that have been added to the standard RM fact types.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Check all custom fact types and and their roles and sentences.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Check and edit any local sentences.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Check all imported source templates and edit as necessary.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Check all sources and edit as necessary.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">Check all repositories and edit as necessary. County has been added to the city field.<\/span><\/p>"
})
