hmLoadTopic({
hmKeywords:"",
hmTitle:"Using a source template",
hmDescription:"There are three template fields, Footnote Template, Short Footnote Template and Bibliography Template. They are all created in the same way. The only differences are the fields...",
hmPrevLink:"creating-a-source-template.html",
hmNextLink:"source-template-language.html",
hmParentLink:"source-templates.html",
hmBreadCrumbs:"<a href=\"working-with-sources.html\">Working with Sources<\/a> &gt; <a href=\"source-templates.html\">Source templates<\/a>",
hmTitlePath:"Working with Sources > Source templates > Using a source template",
hmHeader:"<h1 class=\"p_Heading1\" style=\"page-break-after: avoid;\"><span class=\"f_Heading1\">Using a source template<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_Normal\">There are three template fields, Footnote Template, Short Footnote Template and Bibliography Template. They are all created in the same way. The only differences are the fields used, the order of the fields, the field options used for the lead (first) field, where a shortened (abbreviated) form is used, and the punctuation.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">To build a source template, you would drag the fields from the field list on the left to a template on the right. You can also type in the field name, but you have to remember to add the square brackets and spell the name as shown at the left. You would also add the punctuation, text, field options, and switches to complete the template. For a full discussion of the template language, see the topic Source Template Language.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">The following examples illustrate a number of techniques that you can use when building a template.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Example 1<\/span><\/h2>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<div class=\"p_Normal\"><img alt=\"RM9_Sources-Template-1\" style=\"width:90%;max-width:955px;height:auto;border:none\" src=\".\/images\/rm9_sources-template-1.jpg\"\/><\/div>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">The field options, switches and formatting codes used above include<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">:Caps – capitalize the first letter of the first word, to ensure the entry starts with a capital letter <\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">:Year – display the year from the date field <\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">:Abbrev – use alternate text (text following || in the field) if found, otherwise use the text entered<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">:Reverse – reverse the elements entered, in this case the name of the compiler, but can also apply to a place <\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 1.6250rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_Bullet\">Prefixes that denote rank are not moved to the end of the name after the given name as required by some style guides – they remain before the given name, i.e. Major Thomas Grong, when reversed would become Grong, Major Thomas rather than Grong, Thomas, Major.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">&lt;[field] ,&gt; – the &lt; &gt; brackets indicate a simple conditional switch. If the [field] has data entered into it (one or more characters), the content of the field is displayed plus the space and comma. This technique makes the punctuation optional so it won\'t appear if the associated field contains no data.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">&lt;. [field:Caps]&gt; – similar to the above, but inserted the punctuation before the field data, adding a period to end the previous sentence and starting a new sentence in this case. The :Caps option was included to force the first letter in the field to be capitalized.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">&lt;sc&gt; ... &lt;\/sc&gt; – convert the lower case textual characters to small caps <\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">&lt;![StreetAddress|&lt;sc&gt;address for private use&lt;\/sc&gt;&gt; &nbsp;– this uses the privacy switch (syntax is &quot;&lt;! private | public\/non-private &gt;&quot;). This switch tells RootsMagic to display the first part only if the user chooses to display private data, otherwise the second part would be displayed. In this case, the street address would be only shown if the user chose to see the private data. In all other cases, the phrase &quot;address for private use&quot; in small caps would be shown.<\/span><\/p>\n\r<p class=\"p_Bullet\"><span class=\"f_Bullet\">Punctuation – you\'ll notice that punctuation between groups of fields tends to be commas or semi-colons in the footnotes and periods in the bibliography. Study your style guide to determine the punctuation that is required.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Example 2<\/span><\/h2>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<div class=\"p_Normal\"><img alt=\"RM9_Sources-Template-2\" style=\"width:90%;max-width:984px;height:auto;border:none\" src=\".\/images\/rm9_sources-template-2.jpg\"\/><\/div>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Additional field options, switches and formatting codes used here that were not mentioned above <\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">&lt;i&gt;[Title]&lt;: [SubTitle]&gt;&lt;\/i&gt; – This example uses two things: &lt;i&gt; &lt;\/i&gt; for italics formatting, and &lt;: [SubTitle]&gt; in a conditional switch to include the colon and space if the user enters a subtitle<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">[field:Lower:Abbrev] – This illustrates using multiple options, forcing the text to lower case, and use the alternate text (entered after ||) if available. Whether the alternate text is used or note, text will be in lower case.<\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">:Surname – use the surname only of the author. <\/span><\/p>\n\r<p class=\"p_Bullet\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Bullet\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_Bullet\">&lt;[PubPlace]|N.p.&gt; – this tells RootsMagic to display the first part (before the &quot;|&quot; bar) if there is data entered into the field, or use the second part (after the &quot;|&quot;) if there is no data entered into the field. This technique lets you set up default text to be inserted if the user doesn\'t enter anything. In other cases, it can be used to enter standard wording, which the user can overwrite by entering a value. This is used in online templates to insert the word &quot;accessed&quot;, &lt;[AccessType]|accessed&gt;, but the user can still enter another word of phrase, such as printed or downloaded or whatever.<\/span><\/p>\n\r<p class=\"p_Bullet\"><span class=\"f_Bullet\">When using the above technique, you must remember to format the case of the text following the | bar. For instance, if you use :Caps to capitalize the first letter in the field, you must capitalize the first letter of the text &nbsp;you enter, as in &lt;[ItemType:Caps]|Card file&gt;.<\/span><\/p>\n\r<p class=\"p_Bullet\"><span class=\"f_Bullet\">You cannot use the above technique when you want to make the field optional, because the text following the &quot;|&quot; bar always results in text being present, either from the field or from the default text.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Example 3<\/span><\/h2>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<div class=\"p_Normal\"><img alt=\"RM9_Sources-Template-3\" style=\"width:90%;max-width:984px;height:auto;border:none\" src=\".\/images\/rm9_sources-template-3.jpg\"\/><\/div>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Additional field options, switches and formatting codes used here that were not mentioned above <\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>&lt; [&lt;[TranslatedName]&gt;]&gt; – This example illustrates a technique you can use to add square brackets around a field name. By entering the field name within conditional angle brackets, the outer pair of square brackets are treated as square brackets, and not as part of the field name.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Example 4<\/span><\/h2>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<div class=\"p_Normal\"><img alt=\"RM9_Sources-Template-4\" style=\"width:90%;max-width:984px;height:auto;border:none\" src=\".\/images\/rm9_sources-template-4.jpg\"\/><\/div>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Additional coding used here that was not mentioned above:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>&lt;i&gt;&lt;[NewspaperPlace|Newspaper]&gt;&lt;\/i&gt; – This example uses two newspaper name fields, one for the regular name, the second for the newspaper name with a place inserted. Note the placement of these two elements in the Footnote template. A simple switch is used to display the name with the place if it is entered, or the newspaper name if the place version is not entered. <\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>&lt;; [CreditLine]&gt; – This field allows users to enter the original source of the source for online images.<\/p>\n\r<p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0;\"><span class=\"f_Normal\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span>&quot;[Article]&lt;?[SpecificContent]|,&quot; [SpecificContent].|.&quot;&gt; – This code solves the problem of punctuation that is dependent on whether a field has content or not. You cannot simply use a period at the end of the template. If there is no content, the period has to appear inside the closing quote, otherwise a comma is required inside the closing quote and the period would appear at the end. Thus, if the field [SpecificContent] has data, a comma and a closing quote is inserted before the content is displayed, otherwise if the field is empty, the period and closing quote are displayed.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r"
})
