hmLoadTopic({
hmKeywords:"",
hmTitle:"Using Sentence templates",
hmDescription:"Sentence Templates are the heart of narrative reports in RootsMagic. Sentence templates allow you to tell RootsMagic how to write a sentence when a particular role for a fact...",
hmPrevLink:"fact-sentences.html",
hmNextLink:"customizing-sentences.html",
hmParentLink:"fact-sentences.html",
hmBreadCrumbs:"<a href=\"working-with-facts.html\">Working with Facts<\/a> &gt; <a href=\"fact-sentences.html\">Fact sentences<\/a>",
hmTitlePath:"Working with Facts > Fact sentences > Using Sentence templates",
hmHeader:"<h1 class=\"p_Heading1\" style=\"page-break-after: avoid;\"><span class=\"f_Heading1\">Using Sentence templates<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_Normal\">Sentence Templates are the heart of narrative reports in RootsMagic. Sentence templates allow you to tell RootsMagic how to write a sentence when a particular role for a fact type is encountered in narrative reports or websites. (The template language is described in depth in the help topic, Sentence Template Language.)<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<h2 class=\"p_Heading2\" style=\"page-break-after: avoid;\"><span class=\"f_Heading2\">Basic concepts<\/span><\/h2>\n\r<p class=\"p_Normal\">You simply write a sentence inserting &quot;fields&quot; to show where things like names, dates, and places fit, to compose sentences.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">For example, if you wanted the sentence for the child (the principal person) in a birth fact to read:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">John Smith was born on 5 January 1900 at 22 Any Street in Avon, Polk County, Iowa.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Then you would write a sentence template like:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[person]&nbsp;was&nbsp;born&nbsp;[date]&nbsp;[placedetails]&nbsp;[place].<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">When RootsMagic encounters the person’s birth fact when writing a narrative report, it takes this template and replaces<span style=\"font-weight: bold;\"> [person]<\/span> with the person’s name, <span style=\"font-weight: bold;\">[date]<\/span> with the date of the birth, <span style=\"font-weight: bold;\">[placedetails]<\/span> with the specific location (facility, address, etc.) of birth, and <span style=\"font-weight: bold;\">[place]<\/span> with the place of birth.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Notice that when RootsMagic replaces [date] with the date, it adds the word &quot;on&quot; or &quot;in&quot; as appropriate, so you don’t need to take that into account in your template. Also, when RootsMagic replaces <span style=\"font-weight: bold;\">[placedetails]<\/span> with the place details and <span style=\"font-weight: bold;\">[place]<\/span> with the place, it automatically adds an <span style=\"font-weight: bold;\">&quot;at&quot;<\/span> prefix before place details and <span style=\"font-weight: bold;\">&quot;in&quot;<\/span> before the place so that you don’t have to include these words to the sentence template.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">However, if there was no data entered into the <span style=\"font-weight: bold;\">[date]<\/span>, <span style=\"font-weight: bold;\">[place]<\/span>, or <span style=\"font-weight: bold;\">[placedetails]<\/span> fields, the resulting sentence would read<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">John Smith was born .<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">This is because there are spaces between the fields. To avoid these extra spaces, &quot;conditional angle brackets&quot; are inserted around each field including the space before it, as:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[person]&nbsp;was&nbsp;born&lt;&nbsp;[date]&gt;&lt;&nbsp;[placedetails]&gt;&lt;&nbsp;[place]&gt;.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">If a field is empty, the condition looking for data in the field would be false and anything within the angle brackets would not be shown. This ensures that the sentence will still read properly even if any of the date or place or place details fields are blank for a particular usage of the fact.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">To avoid a sentence like<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Lt. Col. John Harold &quot;Harry&quot; Doe, MD was born in 1827 in Barnet, Caledonia County, Vermont.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">where a rank or other prefix and\/or suffix earned later in life is shown for a newborn, you can control the portions of the name that are used, as in<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[person:Given:Surname]&nbsp;was&nbsp;born&lt;&nbsp;[date]&gt;&lt;&nbsp;[placedetails]&gt;&lt;&nbsp;[place]&gt;.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">The<span style=\"font-weight: bold;\"> :Given:Surname<\/span> suffixes on the field name are called field options, and tell RootsMagic to only insert the <span style=\"font-weight: bold;\">Given names<\/span> and the <span style=\"font-weight: bold;\">Surname<\/span> for this instance of the field <span style=\"font-weight: bold;\">name<\/span>, thus the sentence would read<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">John Harold Doe was born in 1827 in Barnet, Caledonia County, Vermont.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Alternately, you could change the template to read<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[person]&nbsp;was&nbsp;born&nbsp;[person:Given:Surname]&lt;&nbsp;[date]&gt;&lt;&nbsp;[placedetails]&gt;&lt;&nbsp;[place]&gt;.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">which would read<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Lt. Col. John Harold &quot;Harry&quot; Doe, MD was born John Harold Doe in 1827 in Barnet, Caledonia County, Vermont.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">This introduces the person by their full name at maturity, yet indicates that their birth name was not as elaborate.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Other variations of the basic name include: <span class=\"f_CodeExample\">[person:nickname:surname]<\/span> and <span class=\"f_CodeExample\">[person:casual]<\/span>.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">The first, <span class=\"f_CodeExample\">[person:nickname:surname]<\/span>, inserted into our basic sentence above, would result in:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Harry Doe was born in 1827 in Barnet, Caledonia County, Vermont.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">The second variation, <span class=\"f_CodeExample\">[person:casual]<\/span>, would show the nickname if one was entered, or the first name if there was no nickname entered.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\"><span style=\"font-weight: bold;\">Place and Date field options<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">The above examples dealt with name variations. However,<span style=\"font-weight: bold;\"> [place], [placedetails]<\/span> and <span style=\"font-weight: bold;\">[date]<\/span> fields can also have variations. Let\'s look at the following template<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_CodeExample\"><span class=\"f_CodeExample\">[person:Given:Surname:Suffix]&nbsp;graduated&lt;&nbsp;in&nbsp;[Date:Year]&gt;&lt;&nbsp;from&nbsp;[PlaceDetails:Plain]&gt;&lt;&nbsp;in&nbsp;[Place:Short]&gt;.<\/span><\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">With the appropriate values entered into the fields (for our John Doe above), this sentence could read:<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">John Harold Doe MD graduated in 1865 from Harvard Medical School in Boston, Mass.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">You\'ll notice that each of the three fields, <span style=\"font-weight: bold;\">[place], [placedetails]<\/span> and<span style=\"font-weight: bold;\"> [date]<\/span>, has been modified. Let\'s look at the changes.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">The <span style=\"font-weight: bold;\">&lt; [date]&gt;<\/span> was initially modified so that only the year would be shown <span style=\"font-weight: bold;\">&lt; [date:year]&gt;<\/span>. However, when the <span style=\"font-weight: bold;\">:year<\/span> option was added, the preposition <span style=\"font-weight: bold;\">&quot;in&quot;<\/span> or <span style=\"font-weight: bold;\">&quot;on&quot;<\/span> was no longer automatically added, hence the addition of the <span style=\"font-weight: bold;\">&quot;in&quot;<\/span> before the field.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">The <span style=\"font-weight: bold;\">&lt; [placedetails]&gt;<\/span> field was modified to <span style=\"font-weight: bold;\">&lt; from [placedetails]&gt;<\/span> to initially change the preposition to <span style=\"font-weight: bold;\">&quot;from&quot;<\/span> for better readability. However, this created the phrase &quot;from at Harvard Medical School&quot;. The <span style=\"font-weight: bold;\">:plain<\/span> field option, tells RootsMagic to not insert a preposition, so the sentence reads correctly. (The<span style=\"font-weight: bold;\"> :plain<\/span> field option works the same way with<span style=\"font-weight: bold;\"> [date]<\/span> and<span style=\"font-weight: bold;\"> [place]<\/span> fields.)<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">Finally the <span style=\"font-weight: bold;\">&lt; [place]&gt;<\/span> field was modified to show the <a href=\"place-list.html\" class=\"topiclink\">abbreviated form of the place name<\/a> as entered into the <span style=\"font-weight: bold;\">Places &gt; Edit Place Panel &gt; Abbrev<\/span> field using the<span style=\"font-weight: bold;\"> [place:short] <\/span>field option. This option allows you to use the full place name as you originally entered it in the first instance, but use the shortened version in subsequent instances, but it will require you to customize each local fact or role sentence. Another option is <span style=\"font-weight: bold;\">[place:first]<\/span> to use the first part of the place field, rather then the whole place field data.<\/p>\n\r<p class=\"p_Normal\">&nbsp;<\/p>\n\r<p class=\"p_Normal\">To see the many other Fields, Field options, and conditional Switches available in RootsMagic, you are encouraged to read the help topic, <a href=\"sentence-template-language.html\" class=\"topiclink\">Sentence Template Language<\/a>.<\/p>\n\r"
})
